#include "calc.h"

#ifdef USE_TI92PLUS
	#define USE_TIV200
#endif

#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN
#define NO_EXIT_SUPPORT
#include <tigcclib.h>
#include "Structures.h"
#include "Constantes.h"
#include "Sprites.h"
#include "langue.h"

#define gauche		(CALCULATOR?0x10:0x2)
#define haut		(CALCULATOR?_rowread(0x3FE)&0x20:_rowread(0x7E)&0x1)
#define droite		(CALCULATOR?0x40:0x8)
#define bas			(CALCULATOR?_rowread(0x3FE)&0x80:_rowread(0x7E)&0x4)
#define esc			(CALCULATOR?_rowread(0x2FF)&0x40:_rowread(0x3F)&0x1)
#define scnd		(CALCULATOR?_rowread(0x3FE)&0x8:_rowread(0x7E)&0x10) // ([HAND] pour TI-92+)
#define apps		(CALCULATOR?_rowread(0x37F)&0x40:_rowread(0x5F)&0x1)
#define clear		(CALCULATOR?_rowread(0x37F)&0x20:_rowread(0x7D)&0x40)
#define plus		(CALCULATOR?_rowread(0x2FF)&0x10:_rowread(0x7D)&0x2)
#define moins		(CALCULATOR?_rowread(0x1FF)&0x1:_rowread(0x7D)&0x4)
#define directions (CALCULATOR?0x3FE:0x7E)

//#define DBG

void Menu(void);
SYM_ENTRY *OpenFile(void);
char *LoadMap(void);
void Jeu(char *niveaux);
void AfficheMap(MAP *map,short ligneinit,short offset);
void AfficheLigne(short col1,short col2,short y1,short y2,void *dest);
void HLine_OR(short x1 asm("%d0"),short x2 asm("%d1"),short y asm("%d2"),void *dest asm("%a0"));
void HLine_OR2(short x1 asm("%d0"),short x2 asm("%d1"),short y asm("%d2"),void *dest asm("%a0"));
void Sprite16_TRAN(short asm("%d0"),short asm("%d1"),short* asm("%a1"),void* asm("%a0"));
void Sprite8_OR_R(short asm("%d0"),char* asm("%a1"),void* asm("%a0"));
void AIOn(void);
void AIOff(void);
#define GetBit(d,b) ((d) & 1<<(b))

void *vecran;
void *plane0,*plane1;
INT_HANDLER ai1,ai5;
//extern char *Symbol;
//extern SYM_STR SymbolSYMSTR;
extern long magic;
extern short Nlevel;

volatile short timer;
DEFINE_INT_HANDLER(CountFPS)
{
	timer++;
}

void _main(void)
{
	vecran=malloc(3840*2);
	if(!vecran)
		return;
	plane0=vecran;
	plane1=vecran+3840;
	timer=0;
	AIOff();
	if(GrayOn())
		Menu();
	AIOn();
	free(vecran);
}

void Menu(void)
{
	char *File;

	PortSet(GetPlane(1),239,127);
	if((File=LoadMap()))
	{
		Jeu(File+2+4);
//		EM_moveSymToExtMem(SymbolSYMSTR,HS_NULL);
	}
	PortRestore();
}

char *LoadMap(void)
{
   return (char *)(&magic);
/*	SYM_ENTRY *ptrsym;

	FontSetSys(1);
	do
	{
		ptrsym=OpenFile();
		if((long)ptrsym<0)
			return 0;
	}while(!ptrsym);
	if(ptrsym->flags.bits.archived)	// la map est archive
	{
		if(!(EM_moveSymFromExtMem(SymbolSYMSTR,HS_NULL)))
			return 0;
		if(!(ptrsym=SymFindPtr(SymbolSYMSTR,0)))
			return 0;
	}
	return HeapDeref(ptrsym->handle);*/
}

void Jeu(char *niveaux)
{
	short ligne,offset,x,pos,h,hi,score0,score1,score2,score;
	unsigned short touches,ecrevisse=0;
	NIVEAU *niveau;
	short levelactif;
	MAP map;
	void *getplane0,*getplane1;
	unsigned char ballesprt;
	
//	nlevel=*((unsigned short *)niveaux);
	levelactif=0;

	do
	{
		clrscr();
		DrawStr(0,0,choisirniveau,1);
		MoveTo(0,10);
		printf("%d",levelactif+1);
		while(_rowread(0));
		while(!_rowread(0));
		if(_keytest(RR_RIGHT) && levelactif<Nlevel-1)
			levelactif++;
		if(_keytest(RR_LEFT) && levelactif)
			levelactif--;
		if(_keytest(RR_ESC))
			return;
	}while(!_keytest(RR_2ND));

	niveau=(NIVEAU *)(niveaux);
	{
		short i;
		for(i=levelactif;i--;)
		{
			(char *)niveau+=niveau->taille*2+10+2+2;
		}
	}

	while(levelactif<Nlevel)
	{
		map.taille=niveau->taille;
		map.map0=niveau->map;
		map.map1=niveau->map+map.taille;
		ligne=offset=0;
		x=(LCD_WIDTH/2-8-(CALCULATOR?-2:1))<<7;
		pos=((x>>7)+8)/LARG;
		h=hi=0;
		ballesprt=0;
		score0=score1=score2=0;
		getplane0=GetPlane(0);
		getplane1=GetPlane(1);
		clrscr();
		printf(debniveau,levelactif+1,niveau->hs,niveau->nom);
		while(_rowread(0));	// On attend que toutes les touches soient relches
		while(!_rowread(0));
		while(_rowread(0));
		do
		{
			memset(vecran,0,3840*2);
			AfficheMap(&map,ligne,offset);
			Sprite16_TRAN(x>>7,LCD_HEIGHT-16-h,balles[((ballesprt++)>>1) & 7],vecran);
			Sprite8_OR_R(0,num[score2],plane1);
			Sprite8_OR_R(5,num[score1],plane1);
			Sprite8_OR_R(10,num[score0],plane1);
			memcpy(getplane0,plane0,3840);
			memcpy(getplane1,plane1,3840);
			touches=_rowread(directions);
			if((touches & droite) && x<((LCD_WIDTH-16)<<7)-((LARG<<7)/LONG))
			{
				x+=((LARG<<7)/LONG);
				pos=((x>>7)+8)/LARG;
			}
			if((touches & gauche) && x>=((LARG<<7)/LONG))
			{
				x-=((LARG<<7)/LONG);
				pos=((x>>7)+8)/LARG;
			}
			if(!h)
			{
				if(GetBit(map.map0[ligne],pos))
				{
					if(GetBit(map.map1[ligne],pos))	// case noire : on incrmente le score
					{
						if(++score0>9)
							if(score0=0,++score1>9)
								if(score1=0,++score2>9)
									score2=0;
					}
					else	// case gris clair : on saute
						hi=8;
				}
				else	// case blanche : c'est fini
				{
				#ifndef DBG
					if(!GetBit(map.map1[ligne],pos))
					{
						DrawStr(0,10,perdu,4);
						while(_rowread(0));
						while(!_rowread(0));
						while(_rowread(0));
						ecrevisse=0;break;
					}
				#endif
				}
			}
			h+=hi--;
			if(h<=0)
				hi=h=0;
			offset++;
			if(offset>=LONG)
			{
				offset=0;
				ligne++;
				if(ligne>=map.taille)	// Le niveau est fini
					{ecrevisse=2;break;}
			}
			#ifdef DBG
			while(timer<12);
			#endif
			while(timer<8);	// Pour avoir un fps constant
			timer=0;
			if(_keytest(RR_CLEAR))
			{ecrevisse=0;break;}
			if(esc)
				{ecrevisse=1;break;}
		}while(1);

		score=100*score2+10*score1+score0;
		if(score>niveau->hs)
		{
			char nom[11]={"_"};
			short g,i;
		
			AIOn();
			niveau->hs=score;
			DrawStr(16,0,newscore,4);
			DrawStr(0,10,entername,4);
			i=0;
			do
			{
				DrawStr(0,20,nom,4);
				g=ngetchx();
				if(i<10 && ((g>=' ' && g<='Z') || (g>='a' && g<='z')))
					nom[i++]=g;
				if(g==KEY_BACKSPACE && i)
					nom[i--]=0,
					nom[i]=' ';
			}while(g!=KEY_ENTER);
			memcpy(niveau->nom,nom,i);
			niveau->nom[i]=0;
			AIOff();
			if(!GrayOn())
				return;
			getplane0=GetPlane(0);
			getplane1=GetPlane(1);
		}
		while(_rowread(0));	// On attend que toutes les touches soient relches
		if(ecrevisse==1)	// On quitte
			return;
		else if(ecrevisse==2)	// On montre d'un niveau
		{
			(char *)niveau+=niveau->taille*2+10+2+2;
			levelactif++;
		}
		
	}
}

void AfficheMap(MAP *map,short ligneinit,short offset)
{
	short col;
	short actif0,actif1;
	short deb0,deb1;
	short y1,y2,z;
	short ligne;

	ligne=0;
	for(y1=LCD_HEIGHT;y1>=0;)
		{
	
			z=(ligne+1)*LONG-offset;
			y2=FOCALE*HAUTEUR/(FOCALE+z)-(HAUTEUR-LCD_HEIGHT)-1;
	
			actif0=actif1=0;
			deb0=deb1=0;
			for(col=8;col--;)
				{
					if(GetBit(map->map0[ligneinit+ligne],col))	// le sol n'est pas blanc
						{
							if(!actif0)
								actif0=1,
								deb0=col+1;
						}
					else	// Le sol est blanc
						{
							if(actif0)
								{
									actif0=0;
									AfficheLigne(deb0,col+1,y1,y2,plane0);
								}
						}
		
					if(GetBit(map->map1[ligneinit+ligne],col))	// le sol n'est pas blanc
						{
							if(!actif1)
								actif1=1,
								deb1=col+1;
						}
					else	// Le sol est blanc
						{
							if(actif1)
								{
									actif1=0;
									AfficheLigne(deb1,col+1,y1,y2,plane1);
								}
						}
				}
			if(actif0)
				AfficheLigne(deb0,0,y1,y2,plane0);
			if(actif1)
				AfficheLigne(deb1,0,y1,y2,plane1);

			ligne++;
			if(ligneinit+ligne>=map->taille)
				break;
			y1=y2;
		}
}

void AfficheLigne(short col1,short col2,short y1,short y2,void *dest)
{
	register short x1,x2,offset;
	short decal;

	if(y2<0)
		y2=0;

	offset=(y2<<4)-y2;

	for(y1-=y2;y1--;offset+=15,y2++)
	{
		decal=(HAUTEUR-(y2+HAUTEUR-LCD_HEIGHT-1))*(LCD_WIDTH/2)/HAUTEUR;
		x1=col2*(LCD_WIDTH-2*decal)/8+decal;
		x2=col1*(LCD_WIDTH-2*decal)/8+decal;
		HLine_OR2(x1,x2-1,offset,dest);
	}
}

void AIOn(void)
{
	GrayOff();
	SetIntVec(AUTO_INT_1,ai1);
	SetIntVec(AUTO_INT_5,ai5);
}

void AIOff(void)
{
//	GrayOff();
	ai1=GetIntVec(AUTO_INT_1);
	ai5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1,CountFPS);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
}
